<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Library of Linear Inequalities with Names</TITLE>
<link href="suifmath_16.html" rel=Next>
<link href="suifmath_14.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_14.html">previous</A>, <A HREF="suifmath_16.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC15" HREF="suifmath_toc.html#TOC15">Linear Inequalities with Names</A></H1>
<P>
<A NAME="IDX327"></A>
<A NAME="IDX328"></A>

</P>
<P>
<EM>Note: Due to interdependences between the suifmath and dependence
class structures, the implementation of the linear inequalities with
variable names was moved to the dependence library in the current
release.</EM> 

</P>
<P>
When using linear inequalities, variables and constants in the systems
have names associated with them.  Even though it is easy to keep tab of
the names of a single system, when using and combining multiple
inequalities this task becomes much more difficiult.  The linear
inequalities with names were created to simplify this process.

</P>
<P>
A linear inequality with names has a system of linear inequalities
(See section <A HREF="suifmath_9.html#SEC9">Linear Inequality Library</A>).  In addition, it keeps track of the
names of the variables used in the inequality. In the matrix notation
used in the previous chapter, each column has a name associated with it.
The only exception is the first column, which is the constant term.  When
performing operations with two or more systems, the library will first
<STRONG>align</STRONG> the systems. That is, the systems can be combined and the
identical names of both systems will be matched.  In the matrix
notation, after aligning two systems, the <STRONG>n</STRONG>-th column of both
matrices will have the same name associated with it.  If one system uses
a name that is not used in the other system, a column of zeros will be
added to that system.  The only variables that do not match are the
auxiliary variables since in each system auxiliary variables are unique.

</P>
<P>
An expression tree representing a linear affine function can be
translated to and from a system of linear inequalities with names.
Loop bounds and array access functions can also be directly mapped. 

</P>
<P>
Before implementing any algorithms that use named linear inequalities,
the linear inequality calculator <STRONG>LIC</STRONG> can be used (in the rapid
prototyping mode) to prototype and debug the algorithm in a very quick
and easy manner.

</P>
<P>
A linear inequality with names is defined by the class
<CODE>named_lin_ineq</CODE> (section <A HREF="suifmath_18.html#SEC18">Named Linear Inequality</A>) which contains the
names and the system of inequalities.  The names are defined by the class
<CODE>name_table</CODE> (section <A HREF="suifmath_17.html#SEC17">Name Table</A>). Names are represented by a list of
individual name entries.  Each entry is defined by the class
<CODE>name_table_entry</CODE> (section <A HREF="suifmath_16.html#SEC16">Name Table Entry</A>).
<A NAME="IDX329"></A>
<A NAME="IDX330"></A>
<A NAME="IDX331"></A>

</P>

<UL>
<LI><A HREF="suifmath_16.html#SEC16">Name Table Entry</A>
<LI><A HREF="suifmath_17.html#SEC17">Name Table</A>
<LI><A HREF="suifmath_18.html#SEC18">Named Linear Inequality</A>
<LI><A HREF="suifmath_19.html#SEC19">Example 1</A>
<LI><A HREF="suifmath_20.html#SEC20">Example 2</A>
</UL>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_14.html">previous</A>, <A HREF="suifmath_16.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
